#!/usr/bin/perl
#
################################################################################
#
# IPCop mbmongraph Web-Iface
#
# Copyright (C) 2006-2007 Olaf (weizen_42) Westrik
#
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 
#
# You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA 
#
#
# Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License, wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version. 
#
# Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 
#
# Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
#
################################################################################
#
# For support post / read in http://www.ipcop-forum.de
#
# $Id: mbmongraph.cgi 237 2007-08-22 19:33:47Z weizen_42 $
#
# Based on IPCop http://www.ipcop.org graphs.cgi which is partly (c) The SmoothWall Team
# SmoothWall CGIs
#
# 2006-07-12  v0.1.0    more config options
# 2006-08-05  v0.1.1    bugfixed voltage graph. Showed Temp in title
# 2006-08-05  v0.1.2    languege file updates
# 2006-08-09  v0.1.3    bugfixed fan graph. Showed Temp in title
# 2006-08-10  v0.2.0    display temp/fan/volt is now done automagically
# 2006-11-25  v0.3.0    check for updates
# 2007-05-19            display mbmon version
# 2007-06-23  v0.4.0    display min values in graph
# 2007-08-18  v0.4.1    used only once warnings, handle backup
# 2007-08-22  v0.4.2    cleanup some warnings in /var/log/httpd/error_log
#

use strict;

# enable only the following on debugging purpose
use warnings;
use CGI::Carp 'fatalsToBrowser';

use LWP::UserAgent;

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my $debug = 0;
my $version = 'v0.4.2';
my $mbmonversion = `/usr/local/bin/mbmon -h 2>&1 | grep MotherBoard | cut -d ' ' -f 4`;
# checking for new version
my $addonname = 'mbmongraph';
my $onlineversion = '';
my $onlinelink = '';
my $timestamplastcheck = '/var/ipcop/mbmongraph/lastcheck';
my $flagdonotcheck = '/var/ipcop/mbmongraph/noversioncheck';


my %cgiparams=();
$cgiparams{'ACTION'} = '';              # save
my @cgigraphs=();
my @graphs=();

# get rid of used only once warnings
my @onlyonce = ( $Header::table1colour, $Header::table2colour );
undef @onlyonce;

&Header::showhttpheaders();

my $path_graphs = "/home/httpd/html/graphs";

&Header::getcgihash(\%cgiparams);

$ENV{'QUERY_STRING'} =~ s/&//g;
@cgigraphs = split(/graph=/,$ENV{'QUERY_STRING'});
$cgigraphs[1] = '' unless defined $cgigraphs[1];

my %mbmon_settings = ();
my %mbmon_values = ();
&General::readhash("/var/log/mbmon-values", \%mbmon_values);
my $key;


if ( $cgiparams{'ACTION'} eq $Lang::tr{'save'} )
{
  $mbmon_settings{'GRAPH_TEMP'} = 0;
  $mbmon_settings{'GRAPH_FAN'} = 0;
  $mbmon_settings{'GRAPH_VOLT'} = 0;

  foreach my $line (sort keys %cgiparams) 
  {
    if ( index($line, "LINE-") != -1 )
    {
      $mbmon_settings{$line} = 'on';

      if ( index($line, "temp") != -1 ) 
      {
        $mbmon_settings{'GRAPH_TEMP'} = 1;
      }
      elsif ( index($line, "fan") != -1 ) 
      {
        $mbmon_settings{'GRAPH_FAN'} = 1;
      }
      else
      {
        $mbmon_settings{'GRAPH_VOLT'} = 1;
      }
    }

    if ( index($line, "LABEL-") != -1 )
    {
      $mbmon_settings{$line} = $cgiparams{$line};
    }
  }

  &General::writehash("${General::swroot}/mbmongraph/settings", \%mbmon_settings);
}
else
{
  &General::readhash("${General::swroot}/mbmongraph/settings", \%mbmon_settings);
}


my %mbmon_graphs = ();
foreach $key ( sort(keys %mbmon_values) ) 
{
  $mbmon_graphs{$key} = "";
  $mbmon_graphs{$key} = "checked='checked'" if ( defined($mbmon_settings{'LINE-'.$key}) && ($mbmon_settings{'LINE-'.$key} eq 'on') );
  if ( !defined($mbmon_settings{'LABEL-'.$key}) )
  {
    $mbmon_settings{'LABEL-'.$key} = $key;
  }
}

&Header::openpage($Lang::tr{'mbmon graphs'}, 1, '');

&Header::openbigbox('100%', 'left');

# Found this usefull piece of code in BlockOutTraffic AddOn  8-)
#   fwrules.cgi
###############
# DEBUG DEBUG
if ( $debug )
{
&Header::openbox('100%', 'left', 'DEBUG');
my $debugCount = 0;
foreach my $line (sort keys %cgiparams) {
  print "$line = $cgiparams{$line}<br />\n";
  $debugCount++;
}
print "&nbsp;Count: $debugCount\n";
&Header::closebox();
}
# DEBUG DEBUG
###############

#
# Check for new version
#
&checkfornewversion($addonname, $version);
if ( $onlineversion ne '' )
{
  &Header::openbox('100%', 'left', $Lang::tr{'info'});
  print <<END
<table width="100%"><tr>
<td>$Lang::tr{'mbmon newversion'} <a href="$onlinelink" target="_blank"><b>$onlineversion</b></a></td>
</tr></table>
END
;
  &Header::closebox();
}


if ($cgigraphs[1] =~ /(temp|fan|volt)/) 
{
  my $graph = $cgigraphs[1];
  my $graphname = $Lang::tr{"mbmon $cgigraphs[1]"};
  &Header::openbox('100%', 'center', "$graphname");

  if (-e "$path_graphs/mbmon-${graph}-day.png") 
  {
    my $ftime = localtime((stat("$path_graphs/mbmon-${graph}-day.png"))[9]);
    print "<center>";
    print "<b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br /><hr />\n";
    print "<img src='/graphs/mbmon-${graph}-day.png' border='0' /><hr />";
    print "<img src='/graphs/mbmon-${graph}-week.png' border='0' /><hr />";
    print "<img src='/graphs/mbmon-${graph}-month.png' border='0' /><hr />";
    print "<img src='/graphs/mbmon-${graph}-year.png' border='0' />";
  }
  else 
  {
    print $Lang::tr{'no information available'};
  }
  &Header::closebox();
  print "<div align='center'><table width='80%'><tr><td align='center'>";
  print "<a href='/cgi-bin/mbmongraph.cgi'>";
  print "$Lang::tr{'back'}</a></td></tr></table></div>\n";
}
else 
{
  if ( $mbmon_settings{'GRAPH_TEMP'} == 1 )
  {
    &Header::openbox('100%', 'center', "$Lang::tr{'mbmon temp'}");
    if (-e "$path_graphs/mbmon-temp-day.png") 
    {
      my $ftime = localtime((stat("$path_graphs/mbmon-temp-day.png"))[9]);
      print "<center><b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br />\n";
      print "<a href='/cgi-bin/mbmongraph.cgi?graph=temp'>";
      print "<img src='/graphs/mbmon-temp-day.png' border='0' />";
      print "</a>";
    }
    else 
    {
      print $Lang::tr{'no information available'};
    }
    print "<br />\n";
    &Header::closebox();
  }

  if ( $mbmon_settings{'GRAPH_FAN'} == 1 )
  {
    &Header::openbox('100%', 'center', "$Lang::tr{'mbmon fan'}");
    if (-e "$path_graphs/mbmon-fan-day.png") 
    {
      my $ftime = localtime((stat("$path_graphs/mbmon-fan-day.png"))[9]);
      print "<center><b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br />\n";
      print "<a href='/cgi-bin/mbmongraph.cgi?graph=fan'>";
      print "<img src='/graphs/mbmon-fan-day.png' border='0' />";
      print "</a>";
    }
    else 
    {
      print $Lang::tr{'no information available'};
    }
    print "<br />\n";
    &Header::closebox();
  }

  if ( $mbmon_settings{'GRAPH_VOLT'} == 1 )
  {
    &Header::openbox('100%', 'center', "$Lang::tr{'mbmon volt'}");
    if (-e "$path_graphs/mbmon-volt-day.png") 
    {
      my $ftime = localtime((stat("$path_graphs/mbmon-volt-day.png"))[9]);
      print "<center><b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br />\n";
      print "<a href='/cgi-bin/mbmongraph.cgi?graph=volt'>";
      print "<img src='/graphs/mbmon-volt-day.png' border='0' />";
      print "</a>";
    } 
    else 
    {
      print $Lang::tr{'no information available'};
    }
    print "<br />\n";
    &Header::closebox();
  }

  &Header::openbox('100%', 'center', $Lang::tr{'mbmon settings'});

print <<END
<form method='post' action='$ENV{'SCRIPT_NAME'}'>
<table width='100%' border='0' cellspacing='1' cellpadding='0'>
<tr><td align='center' width='10%'><b>$Lang::tr{'mbmon display'}</b></td><td align='center' width='15%'>&nbsp;</td><td align='center' width='15%'><b>$Lang::tr{'mbmon value'}</b></td><td align='left'><b>$Lang::tr{'mbmon label'}</b></td></tr>
END
;

my $i = 0;
foreach $key ( sort(keys %mbmon_values) ) 
{
  if ( $i % 2 )
  {
    print("<tr bgcolor='$Header::table2colour'>");
  }
  else 
  {
    print("<tr bgcolor='$Header::table1colour'>");
  }
  $mbmon_settings{'LABEL-'.$key} = &Header::cleanhtml($mbmon_settings{'LABEL-'.$key});
  print("<td align='center'><input type='checkbox' name='LINE-$key' $mbmon_graphs{$key}/></td>");
  print("<td>$key</td><td align='center'>$mbmon_values{$key}</td>\n");
  print("<td>&nbsp;<input type='text' name='LABEL-$key' value='$mbmon_settings{'LABEL-'.$key}' size='25' /></td></tr>\n");
  $i++;
}

print <<END
</table>

<table width='100%'>
<tr><td class='base' valign='top'>&nbsp;</td><td width='40%' align='center'><input type='submit' name='ACTION' value='$Lang::tr{'save'}' /></td></tr>
</table>

</form>
<hr />
<table width='100%'>
END
;

  if ( $mbmonversion ne '' ) 
  {
    print "<tr><td>&nbsp;</td><td align='right'><b><small><a href='http://www.ipadd.de/binary.html' target='_blank'>mbmon $mbmonversion</a></small></b></td></tr>";
  }
  print "<tr><td>&nbsp;</td><td align='right'><b><small><a href='http://www.ban-solms.de/t/IPCop.html' target='_blank'>mbmongraph $version</a></small></b></td></tr></table>";

  &Header::closebox();
}

&Header::closebigbox();
&Header::closepage();


sub checkfornewversion
{
  my $addon = shift;
  my $version = shift;
  $onlineversion = '';

  if ( -e $flagdonotcheck )
  {
    return;
  }

  # only check if we are online and last check was some time ago
  if ( (! -e '/var/ipcop/red/active') || (-e $timestamplastcheck) && (int(-M $timestamplastcheck) < 5) )
  {
    return;
  }

#workaround to suppress a warning when a variable is used only once
  my @dummy = ( $General::version );
  undef (@dummy);

  my $ua = LWP::UserAgent->new;
  $ua->timeout(120);
  $ua->agent("Mozilla/4.0 (compatible; IPCop $General::version; $version)");
  my $content = $ua->get("http://ipcop-addons.ath.cx/version/$addon");

  if ( $content->is_success )
  {
    # compare the versions, format is v1.2.3
    $content->content =~ /v(\d+).(\d+).(\d+)/;
    my $ver1 = $1;
    my $ver2 = $2;
    my $ver3 = $3;

    $version =~ /v(\d+).(\d+).(\d+)/;

    if ( ($ver1 > $1) || (($ver1 == $1) && ($ver2 > $2)) || (($ver1 == $1) && ($ver2 == $2) && ($ver3 > $3)) )
    {
      $onlineversion = "v$ver1.$ver2.$ver3";

      $content->content =~ /http(.*)/;
      $onlinelink = "http$1";
    }
    else
    {
      # no news, recheck in a couple of days
      system("touch $timestamplastcheck");
    }
  }
}
